/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "DvObj.h"
#include "qplug_if.h"

extern "C" QplugReturnStatus DvQarEXP(vector <DvObject_var>&, vector <DvObject_var>&);

QplugReturnStatus DvQarEXP(vector <DvObject_var>& inputs, vector <DvObject_var>& outputs)
{
	QplugReturnStatus	status;
	
	DvObject_var in_ptr;
	DvObject_var out_ptr;

	DvString out_name;

	status = QPLUG_SUCCESS;


	//	Unpack the input data objects

	in_ptr = inputs[0];

	// Get name of output object

 	out_name = GetSlotText(0);
 	if ( out_name.empty() ) {
    	out_name = "Exp";
    	SetSlotText(0, out_name.c_str());
 	}


	// do arithmetic...


	out_ptr = in_ptr->exp();

	if ( out_ptr.is_nil() ) {
    	QplugAppendTextDisplay ("Arithmetic>> Exp argument has units or is not double\n");
    	return QPLUG_FAILURE; 
	}
 
	if (out_ptr->nError() > 0) QplugAppendTextDisplay( out_ptr->getError().c_str() );

	//	..add  the output series to the list

	outputs.push_back(out_ptr);

	QplugAppendTextDisplay ("Exp: Done\n");
  
	return status;

}

