#include "qcalcEvaluator.h"


void QEvaluatorFills::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	DvObject_var obj_out;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	DvObject_var dobj=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	DvObject_var fill_out=in[1]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[1]->getName()+QString(" invalid");
		ok=false;
		return;
	}

	DvObject_var fill_xref = dobj->get_xref(FILL_VALUE);
	if( fill_xref.is_nil())
	{
		message=QString("Input needs FILLVAL for this filter ");
		ok=false;
		return;
	}
	// create output object

	bool hasD0 = false;
  
	double newValue = fill_out->asDouble();
	double fill = fill_xref->asDouble();

    

	if(dobj->is_dbl())
	{

		obj_out = new DvObject(dobj); // copy obj and xrefs
	 	size_t iMax = dobj->totalSize();
		for(int i=0; i<iMax; i++){
			if( QuIsMatch(obj_out->dbl(i), fill) ) obj_out->dbl(i) = newValue;   // NEEDS REPLACING when FILL -> NaN
		}

		obj_out->change_xref(FILL_VALUE, fill_out);

		out[0]->setValue(obj_out, true);
		return;
	}

   // string and other input types not cleaned - return input object

	message=QString(" Fillval Conversion not handled for this data type\n" );
	ok=false;
	return;
}
