#include "qcalcEvaluator.h"


void QEvaluatorLog10::evaluate(QVector<VInSlot*>& in, QVector<VOutSlot*>& out, bool& ok, QString& message)
{
	ok=true;
	DvObject_var result;
	
	QEvaluator::evaluate(in, out, ok, message);
	if(!ok)
		return;
	
	DvObject_var val1=in[0]->connectedSlot()->getValue(ok);
	if(!ok)
	{
		message=QString("Input ")+in[0]->getName()+QString(" invalid");
		ok=false;
		return;
	}
	
	result = val1->log10();

	if (result.is_nil())
	{
		message=QString("Arithmetic>> Log is not supported between these input types" );
		ok=false;
		return;
	}
	
	out[0]->setValue(result, true);
}

