#ifndef QCALC_TIMELINE_H
#define QCALC_TIMELINE_H

#include "qcalcCommon.h"

class TimeLine
{
	public:
		bool fromData;
		bool regularTT;
		QString fromObjString;
		QString TTString;
		
		TimeLine();
};

class TimeLineHandler: public QObject
{
	Q_OBJECT
	
	public:
		TimeLineHandler();
		
		virtual ~TimeLineHandler();
		
		TimeLine* getTimeLine(const QString& name);
		
		bool deleteTimeLine(const QString& name);
		
		bool addTimeLine(const QString& name, bool fromData=false, bool regularTT=false, const QString& fromObjString="", const QString TTString="");
		
		inline TimeLine* getDefaultTimeLine(){if(timeLines.size()>0) return timeLines[0]; else return NULL;};
		
		QList<QString> getNames();

		QDomElement toXMLElement(QDomDocument& document);
		void fromXMLElement(QDomElement& el);
		
	signals:
		
		void deletedTimeLine(const QString&);
		
		void addedTimeLine(const QString&);
		
		void timeLineChanged(const QString&);
				
	protected:
		
		QVector<QString> names;
		QVector<TimeLine*> timeLines;
};

#endif
