#ifndef QCALC_WINDOW_H
#define QCALC_WINDOW_H

#include <QMainWindow>
#include "qcalcView.h"
#include "qcalcContext.h"

class QcalcFeedback: public QTextEdit
{
	Q_OBJECT

	public:
		QcalcFeedback();
		
		~QcalcFeedback(){;}

    protected slots:

		void closeEvent(QCloseEvent* );
        
	protected:
};

class CalcWindow: public QMainWindow
{
	Q_OBJECT

	public:
		CalcWindow(QWidget* parent, const char* Title);
		
		~CalcWindow();

        QcalcFeedback * feedbackArea;
        CalcScene* myScene;



    protected slots:

        void updateContextWidget();
        void raiseContextWidget();
        void clearContextWidget();
		void keyPressEvent(QKeyEvent*);
		void mousePressEvent(QMouseEvent*);

        void include();
		void restore();
        void save();
		void saveAs();
		void saveSession(QString path);
		void restoreSession(QString path);
		void exportSelection();
		void cut();
		void copy();
		void paste();
		void nextPage();
		void previousPage();
		void changePage(const QString&);
		void updatePageNumber();
		
		void trackingMessage();
		
		void updateBlackBoxMenu();
		void evaluate();
		void evaluatePage(int i=0);
    
        void selectTimeline(const QString&);

	protected:
		CalcView* myView;
        ContextWidget* contextWidget;
		QString fileName;
		QLineEdit * pageLine;
		QMenu* bbOp;
		QPushButton* button2;
				
};

void QcalcShowCalcProto();

CalcWindow* QCalcMakeWindowProto(QWidget *parent, const char * Title);

#endif
