/**********************************************************************
* SCCS id: @(#)CorCoefPlug_utils.c	1.1 14:32:45 12/17/98
************************************************************************
* PROJECT:     Cluster UK CDHF
* COMPONENT:   Correlation Coefficient Plugin 
* MODULE:      CorCoefPlug_utils.h
* LANGUAGE:	   C
* FUNCTION:
* PURPOSE:     C utilities for CorCoefPlugin 
* DESCRIPTION: Test Timetags are Joined, Test Regular Timetags and compute dt
* ARGUMENTS:
* RETURN:
* FUNCTIONS_USED: 
* ALGORITHM: 
* HISTORY:	   Steve Schwartz  Dec 98
***********************************************************************/

#ifndef CORCOEFPLUGUTILS
#define CORCOEFPLUGUTILS

#ifdef __cplusplus
extern "C"{
#endif

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef enum CCutilsSuccessorFailure_e {
	CCUTILSSUCCESS=0,
	CCUTILSFAILURE
}CCutilsSuccessorFailure;



/* C prototypes */

CCutilsSuccessorFailure Test_join (
	double *t1, 
	int n1, 
	double *t2, 
	int n2,
	double tol);

CCutilsSuccessorFailure Test_regular (
	double *t,
	int    n,
	double  *halfdt);


#ifdef __cplusplus
}  /* end extern "C" */
#endif

#endif  /* end define CORCOEFPLUGUTILS */
