/****************************************************************************
							LICENSE

  Copyright (C) 2010 Eugen Sorbalo

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  A copy of the GNU General Public License is available on the internet at:

  http://www.gnu.org/copyleft/gpl.html

  or you can write to:

  The Free Software Foundation, Inc.
  675 Mass Ave
  Cambridge, MA 02139, USA
****************************************************************************/


/**
 * \file ClusterCommons.cpp
 * \author: eugenatjacobs
 * 
 * \brief 
 * 
 */
#include <stdarg.h> 
#include <stdio.h>
#include "qplug_if.h"
#include "qdutil.h"
#include "DvObj.h"
#include "ClusterCommons.h"

using namespace std;

// ---------  class EugClusterAnalysis  ------------------------

EugClusterAnalysis::EugClusterAnalysis() 
{
	deltat_=0;
	nr_satellites_=0;
	nr_coordinates_=0;
	nr_measurements_=0;
	use_dopler_correction_=false;
	do_detrend_=false;

	csd_parameters_.nr_points_overlap_between_subintervals = 0;
	csd_parameters_.nr_points_subinterval = 0;
	csd_parameters_.window_type = TCrossSpectralDensityParameters::kHanning;
}



// ------------  class Status  ---------------------------

Status::Status()
{
	message_ = "";
}

Status::~Status()
{
}

string Status::message() const
{
	string result = "NablaEstimation: ";
	result += message_;
	return result;
}

void Status::PrintMessage(bool to_user, const char fmt[], ...)
{
    va_list args;
    char buffer[2048];
    va_start(args, fmt);
    vsprintf(buffer, fmt, args);
    va_end(args);
    if (to_user)
    	QplugAppendTextDisplay(buffer);
    printf("%s", buffer);
    fflush(stdout);
}


