/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#ifndef IRMTIMETAGS
#define IRMTIMETAGS   // if not defined, define and include rest of file.

#ifndef __cplusplus
#define __cplusplus
#endif

//#define VERBOSE_IRM    // remove comment for extra diagnostics

const double c_re_s= 0047.01;   // speed of light in Re per second
                           // = 2.998e8 ms^-1/( 6.378e6 m Re^-1)

const double gndstn_x = 0.73;   // position of Munich in GEOC Re
const double gndstn_y = 0.15;   // = 48.2 N 11.5 E
const double gndstn_z = 0.67; 

/* C++ prototypes */


QplugReturnStatus  IRMTags_generate (
    DvObject_var &pos, 
    DvObject_var &outtag, 
    int ndata);
    
QplugReturnStatus TestGeocFrame(const char * attstring);
                                
extern "C"  QplugReturnStatus  IRMTags(vector <DvObject_var>&, vector <DvObject_var>&);

#endif    // end define IRMTIMETAGS

