#ifndef QSAS_EDITORS_H_
#define QSAS_EDITORS_H_

#include "qslot.h"
#include "qt_version.h"

#include <QHBoxLayout>
#include "IntervalWidgets.h"
#include <QApplication>

class argSlider : public QWidget {
  
Q_OBJECT

public:
  argSlider(QString title, int indx, int maxN, QWidget *parent=0, char * name=0 );
  ~argSlider();
  
  QguWLinput *numField;
  int num;
  int maxNum;
  int id;
  
public slots:
  void decRec();
  void incRec();
  void adjustRec();
  
signals:
   void QbEchanged(int id, int num);
   
protected:
  
};


class QbEditor : public QGroupBox {

Q_OBJECT

public slots:
	void updateForRec();
	void valueChanged();
  	void timeValueChanged();
  	void SdepValueChanged();
	void changeElement(int,int);
	void setTimeValue();

signals:
   void editorHasInput();

public:
  QbEditor(DvObject_var &dobj, QWidget *parent=0);
  ~QbEditor();
  void makeCopy(DvObject_var &dobj);
  void showDep0Field(bool OKtoShow);
  void showValueField(bool OKtoShow);
  void setData(DvObject_var &dobj);
  
  QWidget * valueBox;
  QWidget * dep0Box;

  DvObject_var D0;
  DvObject_var edited_var;

  int record;
  int maxRec;

  int dimSize;  
  vector<size_t> index;

  QLabel *valueLabel;
  QguWLinput *valueField;
  QguWLinput *SdepField;
  
#if QT_VERSION < 0x040300
  QbDateTimeLineEdit *timeField;
#else
  QbDateTimeWidget *timeField;
#endif

protected:
  
};




# endif // QSAS_EDITORS_H_
