#ifndef GUICONFIG_H
#define GUICONFIG_H

#include <QMainWindow>
#include <QGridLayout>
#include <QLineEdit>
#include <QLabel>
#include <QIntValidator>
#include <QPushButton>
#include <QSpinBox>
#include <QComboBox>
#include <QCheckBox>
#include "qt_version.h"
#include "qprofile.h"
#include "qxml.h"

#include "qpui.h"

class GuiConfig : public QWidget
{
	Q_OBJECT
			
	public:
		GuiConfig();
		
		void setSelectedProfile(QProfile * p);
		
		void updateProfile(QProfile * p);
		
		void setQpuiWidget(QpWindow * w){QPUI_widget=w;}
		
	public slots:
		
		void getQpuiSize();
		
	protected:
		
		QLineEdit * heightLine;
		
		QLineEdit * QpuiSizeLine;
		
		QPushButton * QpuiSizeButton;
		
		QSpinBox * fontSizeBox;
		
		QComboBox * compactUIBox;
		
		QComboBox * slotLRBox;
		
		QComboBox * timeIntervalButtonBox;

		QSpinBox * secDecimalBox;

		QLineEdit * gregorian_start_fld;
        
        QCheckBox * toolbarBox;
		
		int qpuiHeight;
		int qpuiWidth;
		
		QpWindow *QPUI_widget; // pointer to the global QPUI_widget. Not defined as extern, else it won't compile on Windows (dll etc.).
};

#endif
