#ifndef TREE_ITEM_H
#define TREE_ITEM_H

#include <iostream>
#include <QObject>
#include <QTreeWidgetItem>
#include <QApplication>
#include "qdutil.h"

class WList;

class WLItem : public QTreeWidgetItem
{
	
	protected:
		
		QString WL_name;
		QString WL_path;
		bool _isFolder;
		double _startTime;
		int _objType;

	public:
		WLItem(const QString& name="", QTreeWidgetItem* parent=NULL, bool isFolder=false);
		
		~WLItem();
		
		// Accessors
		
		double getTime();
		double getType();
		QString getName() const {return WL_name;}
		QString getPath() const {return WL_path;}
		void updateName();
		void select(bool selected);
				
		bool setFolder(bool isFolder=true);
		bool isFolder() const {return _isFolder;}
		
		int childNumber();

		bool isDescendentOf(WLItem* other);
		bool ancestorInList(QList <QTreeWidgetItem*> &list);
		bool isAncestorOf(WLItem* other);
		WLItem* getChildByName(const QString& name);
		WLItem* getChildByPath(const QString& path);	
		void setChildrenSelected();
		void insertAbove(WLItem* item);
		void insertBelow(WLItem* item);
		void expandChildren();
		bool nameExists(const QString& name);
		int countName(const QString& name);
        void updatePath(QString oldPath);


};

#endif
