//  qexui.h
//
//  Qsas - Data Export Header File
//
//  Tony Allen
//  Nov 2001
//

#ifndef QSAS_DATA_EXP_H_
#define QSAS_DATA_EXP_H_

#include <qfiledialog.h>
#include <qlistview.h>
#include <qstatusbar.h>
#include <qmenubar.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include "qt_version.h"
#include <qgridlayout.h>
#include <qspinbox.h>
#include <qpalette.h>
#include <qapplication.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qpushbutton.h>
#include <qsize.h>

#include <stdlib.h>

#include "DvObj.h"
#include "qie_caa.h"

class DataExportWindow : public QFileDialog {

Q_OBJECT

  QGridLayout* _top_gl;
  QListView* _exp_listview;
  QStatusBar* _status_bar;
  QMenuBar *_menu_bar;
  QGroupBox* options_groupbox;
  QCheckBox* _OverWrite;
  QCheckBox* _Compress;
  QCheckBox* _RecNumOn;
  QCheckBox* _AttachHead;
  QComboBox* _DataDelim;
  QComboBox* _RecDelim;
  QSpinBox* accuracy;
  QSpinBox* accuracyDbl;
  QCheckBox* cdfBackward;
  QDir startDir;
  
public slots:
  void writeFile();
  void setFilter(const QString &);
  void setPrecision(int);
  void setDir();
  
signals:
  void QexMessage(QString txt);
  
public:
  DataExportWindow( QWidget *parent=0, const char *name=0 );
  ~DataExportWindow(){;}
  void buildExportQIEObj(DvJoinList &ObjList);
  void initName();
  void status(const QString& str)
  {_status_bar->showMessage(str);}
  QMenuBar* menu_bar(){ return _menu_bar;}
  QieData *QieDataCont;

protected:
  
};

void QexWriteFile(QWidget *parent, DvJoinList &ObjList);
DvString QexNewName(QString text);
 

                                                                        
# endif // QSAS_DATA_EXP_H_
