 
 /***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include <iostream>
#include <stdio.h>

#include "qt_version.h"
#include <qapplication.h>

#include <QMenu>
#include "qdi.h"


#include "qwui.h"
#include "qds.h"
#include "qie_caa.h"
#include "qexui.h"
#include "qpui.h"
#include "qpolar.h"
#include "qsurface.h"
#include "q3dview.h"
#include "qcalcWindow.h" 
#include "qjui.h"
#include "qprofui.h"
#include "PlotWindow.h"
#include "qprofile.h"
#include "qops.h"

 
 void  AddQwuiMenus();

// Batch Processing

class batchProcess : public QMainWindow {
    
    Q_OBJECT

public:

    batchProcess(qwuiWindow *parent);
    
    QLineEdit *header;
    QStatusBar* _status_bar;
    QMenuBar *_menu_bar;
    qwuiWindow * qwui;
    QString qsas_home;
    QString batchFileName;
    QTextEdit *batchList;
    QPushButton *stepBatch;
    QPushButton *pauseBatch;
    QPushButton *stopBatch;
    QPushButton *playBatch;
    QPushButton *resumeBatch;
    QFile batchInputFile;
    QFile batchStatusFile;
    QTextStream instream;
    QTextStream outstream;
    bool writeLog;
    
    QTime t;
    QDateTime d;
    DvString pluginpath;

    vector <DvString> inPlugList;
    vector <DvString> outPlugList;
    bool exitOnError;
    public slots:
    void openBatchFile();
    void runProcess();
    bool stepProcess();
    void resumeProcess();
    void dismissAndClose();
    
    
        
    protected:
    
    void keyPressEvent(QKeyEvent * e );

    private slots:

};


 // menu helper class for main window
 
 class mainMenu : public QMenu
{
   Q_OBJECT

public:
   mainMenu(QWidget *parent=0, const char *name=0);
   void insertFileItems();
   void insertEditItems();
   void insertCalcItems();
   void insertHelpItems();
   void insertPlotItems();
   void insertPluginMenu();
   void insertProfilesItems();
   
   QDialog *objTypeSelector;
   arrDialog *arrTypeSelector;
   QString def_dir;

signals:
   
public slots:
	void exportET();
	void menuOp(QAction* act);
    void refreshPlugins(bool first);
    void openDS();
    void openCAA();
    void openEvtTable();
    void openExport();
    void launchPlot();
    void launchPolarPlot();
    void launchSurfacePlot();
    void launch3DPlot();
    void launchJoin();
    void launchCalculator();
    void openDataFile(const char *file);
    void launchEditProfile();
    void launchSelectProfile(QAction *);
    void updateProfileList();
	void launchPSD();
	void angleDepTo360();
	void angleDepTo180();
	void angleDepTo0180();
	void angleDepTo90();
	void angleDepReCentre();
    void arrayMatInv();
    void arrayTrace();
    void arrayTranspose();
    void arrayDeterminant();
    void arrayAdjoint();
    void arrayElement();
    void arrayElement_ijk();
    void removeElement();
    void subMatrix();
	void derivative();
	void integral();
	void regression();
    void launchTTOffset();
    void launchSStoTT();
	void launchTItoSec();
	void launchT1T2toSec();
	void launchTT1TT2toSec();
	void mergeTS();
	void array2vec();
    void piecewiseMult();
    void piecewiseDivide();
    void outerProd();
    void innerProd();
    void aTan2Deg();
    void aTan2Rad();
    void openTrig();
    void dotProd();
    void vecProd();
    void normalizeVec();
    void createRegObj();
    void getVariable(DvString&, DvString&, DvEvent&);
    void launchBatchProcess();
    void toggleToolbar();

protected:

	QAction* checkedProfile;
	QAction* toolBar;
private:
   
};

